Imports Microsoft.VisualBasic.FileIO
Imports System.IO

Public Class FrmMain

    Dim transObj As New clsTranscribe
    Dim tempHtmFileName As String = Application.UserAppDataPath + "\temp.htm"
    Public umap As New clsUniquesMap
    Public platformInfo As New clsPlatform

    Private Sub ExitToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitToolStripMenuItem.Click
        umap.SaveToDisk()
        End
    End Sub

    Private Sub TranscribeToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TranscribeToolStripMenuItem.Click
        NotesTextBox.Visible = True
        WebBrowser1.Visible = False
        ListBox1.Items.Clear()
        transObj.Transcribe(SyriacTextBox, OutputTextBox)
        If umap.map.ContainsKey(SyriacTextBox.Text) = False Then
            ListBox1.Items.Add(SyriacTextBox.Text)
        End If
    End Sub

    Private Sub FrmMain_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        umap.SaveToDisk()
    End Sub

    Private Sub FrmMain_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        'MsgBox(Application.UserAppDataPath)
        'application.StartupPath 

        '-- Read dictionary
        umap.ReadFromDisk()

        '-- Check if Serto and Titus fonts both installed
        platformInfo.FontCheck()
        If platformInfo.ErrorMessage <> "" Then
            '-- qqq need a better dialog box with urls to locate fonts
            MsgBox(platformInfo.ErrorMessage, MsgBoxStyle.Critical, "Fonts missing from your system")
        End If

        platformInfo.KeyboardCheck()
        If platformInfo.ErrorMessage <> "" Then
            '-- qqq need a better dialog box with details on how to install keyboard
            MsgBox(platformInfo.ErrorMessage, MsgBoxStyle.Critical, "Keyboards missing from your system")
        End If

    End Sub

    Private Sub ListBox1_MouseClick(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles ListBox1.MouseClick
        If ListBox1.SelectedItem <> "" Then
            '-- new item -- to edit existing item set dlgUniquesEntry.existingentry to something
            dlgUniquesEntry.ItemToEdit = ListBox1.SelectedItem
            dlgUniquesEntry.ShowDialog()
            If umap.map.ContainsKey(SyriacTextBox.Text) = True Then
                ListBox1.Items.Remove(ListBox1.SelectedItem)
            End If
        End If
    End Sub

    Private Sub ListBox1_MouseDoubleClick(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles ListBox1.MouseDoubleClick
        If ListBox1.SelectedItem <> "" Then
            MsgBox(ListBox1.SelectedItem)
        End If
    End Sub

    Private Sub TranscribeAsHTMLToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TranscribeAsHTMLToolStripMenuItem.Click
        ListBox1.Items.Clear()
        NotesTextBox.Visible = False
        WebBrowser1.Navigate("about:blank")
        WebBrowser1.Visible = True
        transObj.TranscribeAsHTMLCodes(SyriacTextBox, OutputTextBox)
        writeTB2disk(OutputTextBox)
        WebBrowser1.Navigate(tempHtmFileName)
    End Sub

    Private Sub writeTB2disk(ByVal mybox As TextBox)
        My.Computer.FileSystem.WriteAllText _
            (tempHtmFileName, "<html><body>" + mybox.Text + "</body></html>", False)

    End Sub

    Private Sub UniquesToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles UniquesToolStripMenuItem.Click

        dlgUniques.ShowDialog()

    End Sub

    Private Sub SaveDictionaryToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SaveDictionaryToolStripMenuItem.Click
        umap.SaveToDisk()
    End Sub

    Private Sub SpellCheckToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SpellCheckToolStripMenuItem.Click

        If Trim(SyriacTextBox.Text) = "" Then
            Exit Sub
        End If
        Dim aStringReader As TextReader = New StringReader(SyriacTextBox.Text)
        Dim par As New TextFieldParser(aStringReader)
        Dim tokens As String()
        par.SetDelimiters(" ", vbTab, ".", ",", ":")
        tokens = par.ReadFields()
        For i As Long = 0 To tokens.Length - 1
            'MsgBox(tokens(i))
            If umap.map.ContainsKey(tokens(i)) = False Then
                ListBox1.Items.Add(tokens(i))
            End If
        Next

    End Sub

    Private Sub SyriacTextBox_GotFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles SyriacTextBox.GotFocus
        platformInfo.ActivateSyriacKeyboard()
    End Sub

    Private Sub OutputTextBox_GotFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles OutputTextBox.GotFocus
        platformInfo.ActivateOriginalKeyboard()
    End Sub

    Private Sub NotesTextBox_GotFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles NotesTextBox.GotFocus
        platformInfo.ActivateOriginalKeyboard()
    End Sub
End Class
