Imports System.Windows.Forms

Public Class dlgUniquesEntry

    '-- Create a pointer
    Private platformInfo As clsPlatform = FrmMain.platformInfo

    '-- Parameter to startup
    Public ItemToEdit As String
    Dim ExistingEntry As New clsUniques

    Private Sub OK_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OK_Button.Click

        Dim u As New clsUniques
        u.stem = Stem.Text
        u.irregular_plural = Irregular_Plural.Text
        u.stem_small = Stem_Small.Text
        u.part = Part.Text
        u.gender = Gender.Text
        u.meaning = Meaning.Text

        '-- Are we editing an existing item?  (Presuming stem cannot change in an update)
        If FrmMain.umap.map.ContainsKey(u.stem) = False Then
            '-- New item
            FrmMain.umap.add(u)
        Else
            '-- Updating existing
            FrmMain.umap.update(u, u)
        End If

        Me.DialogResult = System.Windows.Forms.DialogResult.OK
        Me.Close()
    End Sub

    Private Sub Cancel_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Cancel_Button.Click
        Me.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Me.Close()
    End Sub

    Private Sub dlgUniquesEntry_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        '-- Needs to work for new and existing entries...  how do we pass in a new one?
        '-- clumsy...
        If ItemToEdit Is Nothing Then
            Exit Sub
        End If
        If FrmMain.umap.map.ContainsKey(ItemToEdit) = False Then
            Stem.Text = ItemToEdit
        Else
            Dim myarray As ArrayList = FrmMain.umap.map.Item(ItemToEdit)
            '-- there may be several entries here... this is not a good way to edit something
            '-- existing.  Redo.  Do existing stuff from the View Uniques.
            'Stem.Text = ExistingEntry.stem
            'Stem_Small.Text = ExistingEntry.stem_small
            'Part.Text = ExistingEntry.part
            'Meaning.Text = ExistingEntry.meaning
        End If
    End Sub

    Private Sub Stem_GotFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles Stem.GotFocus
        platformInfo.ActivateSyriacKeyboard()
    End Sub

    Private Sub Stem_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Stem.TextChanged
        If Stem_Small.Text = "" Then
            Stem_Small.Text = Stem.Text
        End If
    End Sub

    Private Sub Stem_Small_GotFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles Stem_Small.GotFocus
        platformInfo.ActivateSyriacKeyboard()
    End Sub

    Private Sub Irregular_Plural_GotFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles Irregular_Plural.GotFocus
        platformInfo.ActivateSyriacKeyboard()
    End Sub

    Private Sub Part_GotFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles Part.GotFocus
        platformInfo.ActivateOriginalKeyboard()
    End Sub

    Private Sub Meaning_GotFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles Meaning.GotFocus
        platformInfo.ActivateOriginalKeyboard()
    End Sub

    Private Sub Gender_GotFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles Gender.GotFocus
        platformInfo.ActivateOriginalKeyboard()
    End Sub
End Class
